"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Contains services anotated with `google.api.http` which
then translate nicely into an OpenAPI V3 definition.
"""
import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import kerfed.protos.common.v1.address_pb2
import kerfed.protos.common.v1.config_pb2
import kerfed.protos.common.v1.outcome_pb2
import kerfed.protos.common.v1.price_pb2
import sys

if sys.version_info >= (3, 8):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing_extensions.final
class PartDocument(google.protobuf.message.Message):
    """This is the API representation of a part."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ASSEMBLY_ID_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    OUTCOME_FIELD_NUMBER: builtins.int
    FABS_FIELD_NUMBER: builtins.int
    assembly_id: builtins.str
    name: builtins.str
    """A user-facing display name."""
    @property
    def outcome(self) -> kerfed.protos.common.v1.outcome_pb2.Outcome:
        """The outcome of processing the part."""
    @property
    def fabs(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PartFabricationSummary]:
        """A summary of available fabrication results."""
    def __init__(
        self,
        *,
        assembly_id: builtins.str = ...,
        name: builtins.str = ...,
        outcome: kerfed.protos.common.v1.outcome_pb2.Outcome | None = ...,
        fabs: collections.abc.Iterable[global___PartFabricationSummary] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["outcome", b"outcome"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["assembly_id", b"assembly_id", "fabs", b"fabs", "name", b"name", "outcome", b"outcome"]) -> None: ...

global___PartDocument = PartDocument

@typing_extensions.final
class PartFabricationSummary(google.protobuf.message.Message):
    """A user-facing summary of fabrication results available."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    FAB_ID_FIELD_NUMBER: builtins.int
    METHOD_ID_FIELD_NUMBER: builtins.int
    OUTCOME_FIELD_NUMBER: builtins.int
    fab_id: builtins.str
    """What is the unique identifier for the fabrication result?"""
    method_id: builtins.str
    """Which method was this analysis for."""
    @property
    def outcome(self) -> kerfed.protos.common.v1.outcome_pb2.Outcome:
        """Did the analysis succeed or fail?"""
    def __init__(
        self,
        *,
        fab_id: builtins.str = ...,
        method_id: builtins.str = ...,
        outcome: kerfed.protos.common.v1.outcome_pb2.Outcome | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["outcome", b"outcome"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["fab_id", b"fab_id", "method_id", b"method_id", "outcome", b"outcome"]) -> None: ...

global___PartFabricationSummary = PartFabricationSummary

@typing_extensions.final
class PartReadRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PART_ID_FIELD_NUMBER: builtins.int
    part_id: builtins.str
    def __init__(
        self,
        *,
        part_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["part_id", b"part_id"]) -> None: ...

global___PartReadRequest = PartReadRequest

@typing_extensions.final
class PartReadResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PART_FIELD_NUMBER: builtins.int
    @property
    def part(self) -> global___PartDocument: ...
    def __init__(
        self,
        *,
        part: global___PartDocument | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["part", b"part"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["part", b"part"]) -> None: ...

global___PartReadResponse = PartReadResponse

@typing_extensions.final
class PartPriceRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PART_ID_FIELD_NUMBER: builtins.int
    CONFIG_FIELD_NUMBER: builtins.int
    SHIPPING_FIELD_NUMBER: builtins.int
    part_id: builtins.str
    @property
    def config(self) -> kerfed.protos.common.v1.config_pb2.PartConfiguration: ...
    @property
    def shipping(self) -> kerfed.protos.common.v1.address_pb2.PostalAddress: ...
    def __init__(
        self,
        *,
        part_id: builtins.str = ...,
        config: kerfed.protos.common.v1.config_pb2.PartConfiguration | None = ...,
        shipping: kerfed.protos.common.v1.address_pb2.PostalAddress | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["config", b"config", "shipping", b"shipping"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["config", b"config", "part_id", b"part_id", "shipping", b"shipping"]) -> None: ...

global___PartPriceRequest = PartPriceRequest

@typing_extensions.final
class PartPriceResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PRICE_FIELD_NUMBER: builtins.int
    @property
    def price(self) -> kerfed.protos.common.v1.price_pb2.LinePrice: ...
    def __init__(
        self,
        *,
        price: kerfed.protos.common.v1.price_pb2.LinePrice | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["price", b"price"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["price", b"price"]) -> None: ...

global___PartPriceResponse = PartPriceResponse
